<?php

/* Reminder: always indent with 4 spaces (no tabs). */

/**
 * DVRS Improving Transition Outcomes
 *
 * License Details To Be Determined
 *
 */
  
/**
 * Base Command
 */
require_once 'BaseCommandUser.php';

/**
 * User domain object
 */
require_once 'PHPARCH/Account.php';

/**
 * PEAR's Exception class
 */
require_once 'PEAR/Exception.php';

/**
 * DAO factory
 */
require_once 'system/DataAccess/DAO.php';

/**
 * Login command
 *
 * @copyright 2005 Iowa Department of Vocational and Rehabilitation Services
 * @author Tony Bibbs <Tony Bibbs <tony@geeklog.net>>
 * @todo Add better error handling
 *
 */
class PHPARCH_LogoffCommand extends PHPARCH_BaseCommandUser {
    /**
     * Logs a user in
     *
     * Uses ITE's Enterprise Authentication and Authorization (A&A) Service to authenticate a user
     * and load the associated privileges in the system.
     *
     * @author Tony Bibbs <Tony Bibbs <tony@geeklog.net>>
     * @access public
     * 
     */
	public function execute()
	{
	    unset($_SESSION['user']);
	    
	    // go to home page
		return 'goLogin';
	}
}

?>