<?php

/* Reminder: always indent with 4 spaces (no tabs). */

/**
 * Bring in the Geeklog 2 configuration file
 */
require_once '../config.php';

/**
 * Bring in the MVC controller 
 */
require_once 'Geeklog/MVCnPHP/Controller.php';

/**
 * Bring in Propel
 */
require_once 'propel/Propel.php';

// Initialize Propel
Propel::init($conf['path_propel_config']);

// Start a PHP-based session
session_start();

// Load the MVC configuration
$configData = $conf['path'] . 'mvcconfig.xml';

// Instanstiate the controller
$controller = new MVCnPHP_Controller($configData, MVC_XML);
$controller->setBaseURL($conf['site_url']);
$controller->setViewDir($conf['path_views']);
$controller->setCommandDir($conf['path_commands']);

try {
    // Process the request
    $controller->processRequest();
} catch (Exception $e) {
    // This will directly call a view to show any uncaught exceptions.
    $_REQUEST['exception'] = $e;
    require_once "{$conf['path_views']}PHPARCH_showErrorView.php";
    $errorView = new PHPARCH_showErrorView();
    $errorView->getView();
}

?>