<?php

/**
 * MVCnPHP - ArrayLoader.class.php
 *
 * This source file is subject to version 2.02 of the PHP license,
 * that is bundled with this package in the file LICENSE, and is
 * available at through the world-wide-web at
 * http://www.php.net/license/2_02.txt.
 * If you did not receive a copy of the PHP license and are unable to
 * obtain it through the world-wide-web, please send a note to
 * license@php.net so we can mail you a copy immediately.
 *
 * @author Tony Bibbs <tony@geeklog.net>
 * @copyright Tony Bibbs 2003
 * @package net.geeklog.mvc
 * @version $Id: ArrayLoader.php,v 1.4 2005/03/17 05:08:37 tony Exp $
 *
 */

/**
* Base Loader class which does most of the work
*/
require_once 'BaseLoader.php';

/**
* This loader creates a mapping from an PHP array
*
* @author Tony Bibbs <tony@geeklog.net>
* @package net.geeklog.mvc
* @see LoaderFactory
*
*/
class MVCnPHP_ArrayLoader extends MVCnPHP_BaseLoader {
    
    /**
    * Gets config data for given object in the form of
    * a mapping object
    *
    * @author Tony Bibbs <tony@geeklog.net>
    * @access public
    * @param string $name Name of object to get mapping for
    * @param string $viewsDir Directory where controllers views are stored
    * @param string $commandsDir DIrectory where controllers commands are stored
    * @param string $baseURL Base URL, all redirects are relative to this URL
    * @param array $arrayData Array of configuration data
    * @return object Mapping object
    *
    */
    public function getMapping($name, $viewsDir, $commandsDir, $baseURL, $arrayData = '')
    {
        if (!is_array($arrayData) AND !is_array($this->arrayData)) {
            return false;
        }
        
        if (empty($this->arrayData)) {
            $this->arrayData = $arrayData;
        }
        return parent::getMapping($name, $viewsDir, $commandsDir, $baseURL, $this->arrayData);
    }
}

?>