<?php

require_once 'Geeklog/MVCnPHP/BaseView.php';
require_once 'Geeklog/MVCnPHP/XMLLoader.php';
require_once 'HTML/Template/Flexy.php';
require_once 'HTML/Template/Flexy/Element.php';

class MVCnPHP_EditorView extends MVCnPHP_BaseView {
    protected $flexyHandle = null;
    public $configFile = null;
    public $viewArray = array();
    public $commandArray = array();    
    public $flexyElements = null;
    
    public function __construct()
    {
        $this->configFile = $_REQUEST['xmlConfig'];
        
        $this->options = array(
            'templateDir'   => dirname(__FILE__),
            'compileDir'    => dirname(__FILE__) . '/compiled_templates',
            'forceCompile'  => 0,
            'debug'         => 0,
            'locale'        => 'en'
        );
           
        $this->flexyHandle = new HTML_Template_Flexy($this->options);
    }
    
    public function getView()
	{
	    $loader= new MVCnPHP_XMLLoader(file_get_contents($this->configFile));
        $loader->xmlToArray();
        $configArray = $loader->getArrayData();
        $this->viewArray = $configArray['views'];
        $this->commandArray = $configArray['commands'];
        $this->populateDropDowns();        
        $this->flexyElements['compile'] = new HTML_Template_Flexy_Element();
        $this->flexyElements['compile']->setOptions(array('yes'=>'Yes','no'=>'No'), false);
        if ($configArray['compile'] == 'false') {
            $this->flexyElements['compile']->setValue('no');
        } else {
            $this->flexyElements['compile']->setValue('yes');
        }
		//$this->flexyElements['compile']->setValue('c');*/
		$this->flexyElements['ui'] = new HTML_Template_Flexy_Element();
        $this->flexyElements['ui']->setOptions(array('yes'=>'Yes','no'=>'No'), false);        
        if ($configArray['ui'] == 'false') {
            $this->flexyElements['ui']->setValue('no');
        } else {
            $this->flexyElements['ui']->setValue('yes');
        }
        $this->flexyHandle->compile('Editor.thtml');
        $this->flexyHandle->outputObject($this, $this->flexyElements);
	}
	
	private function populateDropDowns()
	{
	    foreach ($this->viewArray as $key=>$curView) {
            if (!is_array($curView['forwards'])) {
                $curView['forwards'] = array();
            }
	        /*foreach ($curView['forwards'] as $forwardKey=>$curForward) {
	           $fieldName = sprintf('forwardType_%s_%s', $key, $forwardKey);
	           $this->getDropDownFromArray(
	               array('view'=>'View','command'=>'Command','redirect'=>'Redirect'),
	               $fieldName,$curForward['type'],true,'--Select Type--');	           
	        }*/	        
            for ($i = 1; $i <= 5; $i++) {
                $fieldName = sprintf('forwardType_%s_new%s',$key,$i);
                $this->getDropDownFromArray(
                array('view'=>'View','command'=>'Command','redirect'=>'Redirect'),
                $fieldName,$curForward['type'],false,'--Select Type--');
            }
	         
	    }
	}
	
	/**
     * Builds a drop down from an array
     *
     * @author Tony Bibbs tony.bibbs@iowa.gov
     * @access protected
     * @param array $dataArray Array of data in id->displayValueformat to show in the drop down
     * @param string $htmlFieldName Name to give the html select tag
     * @param string $setValue Gives the value of the option in the drop down we want to set as
     * the selected item
     * @param boolean $useKeyAsValue Indicates if the keys from $dataArray should be used as the 
     * values for the option tags.
     * @param string $stubText If you want an empty stubbed value pass the text you want shown in 
     * the drop down (i.e. --Select State--)
     *
     */
	protected function getDropDownFromArray($dataArray, $htmlFieldName, $setValue='', 
	   $useKeyAsValue = false, $stubText = '')
	{
		$this->flexyElements[$htmlFieldName] = new HTML_Template_Flexy_Element;
		if (!empty($stubText)) {
		    $resultArray[] = $stubText;
		}
		$this->flexyElements[$htmlFieldName]->setOptions($dataArray, !$useKeyAsValue);
		if (!empty($setValue)) {
			$this->flexyElements[$htmlFieldName]->setValue($setValue);
    	}
	}
	
	public function numViews()
	{
	    return count($this->viewArray);
	}
	
	public function getClassName($objArray)
	{
        return $objArray['name'];
	}
	
	public function loadForwards($objArray)
	{
	    $this->forwards = $objArray['forwards'];
	}
	
	public function getForwardName($forward)
	{
	    return $forward['name'];
	}
	
	public function getForwardTargetyName($forward)
	{
	    return $forward['target'];
	}
	public function checkSelection($forward, $value)
	{
	    if ($forward['type'] == $value) {
	        return '" selected="selected';
	    } else {
	        return '';
	    }
	}
	public function getParentName($objArray)
	{
	    return $objArray['parent'];
	}
}

?>