<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'book' table to 'bookstore' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 *  This class was autogenerated by Propel on:
 *
 * [02/20/05 19:50:56]
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package bookstore.map
 */
class BookMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "bookstore.map.BookMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("bookstore");
		
		$tMap = $this->dbMap->addTable("book");
		$tMap->setPhpName("Book");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("BOOK_ID", "BookId", "int", CreoleTypes::INTEGER, true);
		$tMap->addColumn("TITLE", "Title", "string", CreoleTypes::VARCHAR, true, 255);
		$tMap->addColumn("ISBN", "ISBN", "string", CreoleTypes::VARCHAR, true, 24);
		$tMap->addForeignKey("PUBLISHER_ID", "PublisherId", "int", CreoleTypes::INTEGER, "publisher" , "PUBLISHER_ID", true);
		$tMap->addForeignKey("AUTHOR_ID", "AuthorId", "int", CreoleTypes::INTEGER, "author" , "AUTHOR_ID", true);
        $tMap->addValidator("TITLE", "minLength", "propel.validator.MinLengthValidator", "10", "Book title must be more than 10 characters long.");
				
    }
}
