<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'review' table to 'bookstore' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 *  This class was autogenerated by Propel on:
 *
 * [02/20/05 19:50:56]
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package bookstore.map
 */
class ReviewMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "bookstore.map.ReviewMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("bookstore");
		
		$tMap = $this->dbMap->addTable("review");
		$tMap->setPhpName("Review");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("REVIEW_ID", "ReviewId", "int", CreoleTypes::INTEGER, true);
		$tMap->addColumn("REVIEWED_BY", "ReviewedBy", "string", CreoleTypes::VARCHAR, true, 128);
		$tMap->addColumn("REVIEW_DATE", "ReviewDate", "int", CreoleTypes::DATE, true, null);
		$tMap->addColumn("RECOMMENDED", "Recommended", "boolean", CreoleTypes::BOOLEAN, true, null);
		$tMap->addForeignKey("BOOK_ID", "BookId", "int", CreoleTypes::INTEGER, "book" , "BOOK_ID", true);
        $tMap->addValidator("REVIEWED_BY", "required", "propel.validator.RequiredValidator", "", "The reviewed by field is required.");
				
    }
}
