<?php 

require_once 'propel/om/BaseObject.php';

require_once 'propel/om/Persistent.php';
 

include_once 'propel/util/Criteria.php';

include_once 'bookstore/AuthorPeer.php';

/**
 * Base class that represents a row from the 'author' table.
 *
 * Author Table *
 * This class was autogenerated by Propel on:
 *
 * [02/20/05 19:50:56]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Author class. 
 * 
 * @package bookstore 
 */
abstract class BaseAuthor extends BaseObject implements Persistent {
    
    /** 
     * The Peer class.
     * Instance provides a convenient way of calling static methods on a class
     * that calling code may not be able to identify.
     * @var AuthorPeer
     */
    protected static $peer;

    /**
     * The value for the author_id field.
     * @var int      
     */
    protected $author_id;    

    /**
     * The value for the first_name field.
     * @var string      
     */
    protected $first_name;    

    /**
     * The value for the last_name field.
     * @var string      
     */
    protected $last_name;    
  
    /**
     * Get the AuthorId column value.
     * Author Id     * @return int      
     */
    public function getAuthorId()
    {
        return $this->author_id;
    }


    /**
     * Set the value of `author_id` column.      
     * Author Id     * @param int $v new value
     * @return void
     * @throws PropelException 
     */
    public function setAuthorId($v)
    {
        if ($this->author_id !== $v) {
            $this->author_id = $v;
            $this->modifiedColumns[] = AuthorPeer::AUTHOR_ID;
        }
            
          // update associated Book          
          if ($this->collBooks !== null) {
              for ($i=0,$size=count($this->collBooks); $i < $size; $i++) {
                  $this->collBooks[$i]->setAuthorId($v);
              }
          }
                      
    }

  
    /**
     * Get the FirstName column value.
     * First Name     * @return string      
     */
    public function getFirstName()
    {
        return $this->first_name;
    }


    /**
     * Set the value of `first_name` column.      
     * First Name     * @param string $v new value
     * @return void
     *  
     */
    public function setFirstName($v)
    {
        if ($this->first_name !== $v) {
            $this->first_name = $v;
            $this->modifiedColumns[] = AuthorPeer::FIRST_NAME;
        }
                
    }

  
    /**
     * Get the LastName column value.
     * Last Name     * @return string      
     */
    public function getLastName()
    {
        return $this->last_name;
    }


    /**
     * Set the value of `last_name` column.      
     * Last Name     * @param string $v new value
     * @return void
     *  
     */
    public function setLastName($v)
    {
        if ($this->last_name !== $v) {
            $this->last_name = $v;
            $this->modifiedColumns[] = AuthorPeer::LAST_NAME;
        }
                
    }


    
    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (1-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
     * @param int $startcol 1-based offset column which indicates which restultset column to start with.
     * @return void
     * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate(ResultSet $rs, $startcol = 1)
    {
        try {
            $this->author_id = $rs->getInt($startcol + 0);                    
            $this->first_name = $rs->getString($startcol + 1);                    
            $this->last_name = $rs->getString($startcol + 2);                    
             
            $this->resetModified();
            $this->setNew(false);
        
        } catch (Exception $e) {
            throw new PropelException("Error populating object", $e);
        }        
    
    }
    
    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether or not they have been modified.
     * 
     * @return Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria()
    {        
        $criteria = new Criteria(AuthorPeer::DATABASE_NAME);
        $criteria->add(AuthorPeer::AUTHOR_ID, $this->author_id);
        return $criteria;            
    }
    
    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria()
    {        
        $criteria = new Criteria(AuthorPeer::DATABASE_NAME);
        if ($this->isColumnModified(AuthorPeer::AUTHOR_ID)) $criteria->add(AuthorPeer::AUTHOR_ID, $this->author_id);
        if ($this->isColumnModified(AuthorPeer::FIRST_NAME)) $criteria->add(AuthorPeer::FIRST_NAME, $this->first_name);
        if ($this->isColumnModified(AuthorPeer::LAST_NAME)) $criteria->add(AuthorPeer::LAST_NAME, $this->last_name);
        return $criteria;            
    }
    
    

    /**
     * Collection to store aggregation of collBooks      
     * @var array
     */
    protected $collBooks; 

    /**
     * Temporary storage of collBooks to save a possible db hit in
     * the event objects are add to the collection, but the
     * complete collection is never requested.
     * @return void
     */
    public function initBooks()
    {
        if ($this->collBooks === null) {
            $this->collBooks = array();
        }
    }

    /**
     * Method called to associate a Book object to this object
     * through the Book foreign key attribute
     *
     * @param Book $l $className
     * @return void
     * @throws PropelException
     */
    public function addBook(Book $l)
    {
        $this->collBooks[] = $l;
        $l->setAuthor($this);
    }

    /**
     * The criteria used to select the current contents of collBooks.
     * @var Criteria
     */
    private $lastBooksCriteria = null;

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Author has previously
     * been saved, it will retrieve related Books from storage.
     * If this Author is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @param Connection $con
     * @param Criteria $criteria
     * @throws PropelException
     */
    public function getBooks($criteria = null, $con = null)
    {
        // include the Peer class
        include_once 'bookstore/BookPeer.php';
        if ($criteria === null) {
            $criteria = new Criteria();
        }
                
        if ($this->collBooks === null) {
            if ($this->isNew()) {
               $this->collBooks = array();
            } else {
    
                $criteria->add(BookPeer::AUTHOR_ID, $this->getAuthorId() );

                $this->collBooks = BookPeer::doSelect($criteria, $con);
            }
        } else {
            // criteria has no effect for a new object
            if (!$this->isNew()) {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.

                $criteria->add(BookPeer::AUTHOR_ID, $this->getAuthorId());

                if (!isset($this->lastBooksCriteria) || !$this->lastBooksCriteria->equals($criteria)) {
                    $this->collBooks = BookPeer::doSelect($criteria, $con);
                }
            }
        }
        $this->lastBooksCriteria = $criteria;

        return $this->collBooks;
    }
    

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Author is new, it will return
     * an empty collection; or if this Author has previously
     * been saved, it will retrieve related Books from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in Author.
     */
    public function getBooksJoinPublisher($criteria = null, $con = null)
    {
        if ($criteria === null) {
            $criteria = new Criteria();
        }
        
        if ($this->collBooks === null) {
            if ($this->isNew()) {
               $this->collBooks = array();
            } else {
       
                $criteria->add(BookPeer::AUTHOR_ID, $this->getAuthorId());
                $this->collBooks = BookPeer::doSelectJoinPublisher($criteria, $con);
            }
        } else {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
      
            $criteria->add(BookPeer::AUTHOR_ID, $this->getAuthorId());
            if (!isset($this->lastBooksCriteria) || !$this->lastBooksCriteria->equals($criteria)) {
                $this->collBooks = BookPeer::doSelectJoinPublisher($criteria, $con);
            }
        }
        $this->lastBooksCriteria = $criteria;

        return $this->collBooks;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Author is new, it will return
     * an empty collection; or if this Author has previously
     * been saved, it will retrieve related Books from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in Author.
     */
    public function getBooksJoinAuthor($criteria = null, $con = null)
    {
        if ($criteria === null) {
            $criteria = new Criteria();
        }
        
        if ($this->collBooks === null) {
            if ($this->isNew()) {
               $this->collBooks = array();
            } else {
       
                $criteria->add(BookPeer::AUTHOR_ID, $this->getAuthorId());
                $this->collBooks = BookPeer::doSelectJoinAuthor($criteria, $con);
            }
        } else {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
      
            $criteria->add(BookPeer::AUTHOR_ID, $this->getAuthorId());
            if (!isset($this->lastBooksCriteria) || !$this->lastBooksCriteria->equals($criteria)) {
                $this->collBooks = BookPeer::doSelectJoinAuthor($criteria, $con);
            }
        }
        $this->lastBooksCriteria = $criteria;

        return $this->collBooks;
    }



 
    /**
     * Removes this object from datastore and sets delete attribute.
     * 
     * @param Connection $con
     * @return void
     * @throws PropelException
     * @see BaseObject::setDeleted()
     * @see BaseObject::isDeleted()
     */
    public function delete($con = null)
    {    
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }
        
        if ($con === null)
            $con = Propel::getConnection(AuthorPeer::DATABASE_NAME);

        try {
            $con->begin();
            AuthorPeer::doDelete($this, $con);
            $this->setDeleted(true);
            $con->commit();
        } catch (PropelException $e) {
            $con->rollback();
            throw $e;
        }
    }
    

    /**
     * flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var boolean
     */
    private $alreadyInSave = false;

    /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.  This method
     * wraps the doSave() worker method in a transaction.
     *
     * @param Connection $con
     * @return void
     * @throws PropelException
     */
    public function save($con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }
        
        if ($con === null)
            $con = Propel::getConnection(AuthorPeer::DATABASE_NAME);

        try {
            $con->begin();
            $this->doSave($con);            
            $con->commit();
        } catch (PropelException $e) {
            $con->rollback();
            throw $e;
        }
    }
  
    /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.
     *
     * @param Connection $con
     * @return void
     * @throws PropelException
     */
		protected function doSave($con)    { 
        
     
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            // If this object has been modified, then save it to the database.
            if ($this->isModified()) {
                if ($this->isNew()) {
                    $pk = AuthorPeer::doInsert($this, $con);
					$this->setAuthorId( $pk );  //[IMV] update autoincrement primary key
                    $this->setNew(false);
                } else {
                    AuthorPeer::doUpdate($this, $con);
                }            
                $this->resetModified(); // [HL] After being saved an object is no longer 'modified'
            }
            if ($this->collBooks !== null) {
                for ($i=0,$size=count($this->collBooks); $i < $size; $i++) {
                    $this->collBooks[$i]->save($con);
                }
              }

            $this->alreadyInSave = false;
        }
    }

    /**
     * Validates the objects modified field values.
     * This includes all objects related to this table.
     *
     * @return mixed <code>true</code> if all columns pass validation
     *              or an array of <code>ValidationFailed</code> objects for columns that fail.
     */
    public function validate()
    {
        return $this->doValidate();
    }

    /**
     * flag to prevent endless validation loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var boolean
     */
    protected $alreadyInValidation = false;
  
    /**
     * This function performs the validation work for complex object models.
     * 
     * In addition to checking the current object, all related objects will
     * also be validated.  If all pass then <code>true</code> is returned; otherwise
     * an aggreagated array of ValidationFailed objects will be returned.
     *
     * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
     */
    protected function doValidate()
    {
        if (! $this->alreadyInValidation) {
            $this->alreadyInValidation = true;
            $retval = null;
      
            $failureMap = array();      

            if (($retval = AuthorPeer::doValidate($this)) !== true) {
                $failureMap = array_merge($failureMap, $retval);
            }
      
            if ($this->collBooks !== null) {
                for ($i=0,$size=count($this->collBooks); $i < $size; $i++) {
                    if (($retval = $this->collBooks[$i]->validate()) !== true) {
                        $failureMap = array_merge($failureMap, $retval);
                    }
                }
            }
      
            $this->alreadyInValidation = false;
        }
    
        return (!empty($failureMap) ? $failureMap : true);
    }
  

    /**
     * Set the PrimaryKey.
     *
     * @param mixed author_id Primary key.
     * @return void
     * @throws PropelException     */
    public function setPrimaryKey($key) 
    {        
        $this->setAuthorId($key);
    }
    

    /**
     * Returns an id that differentiates this object from others
     * of its class.
     * @return int 
     */
    public function getPrimaryKey()
    {

        return $this->getAuthorId();

    }

    
    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *  
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     *  
     * @return Author Clone of current object.
     * @throws PropelException
     */
    public function copy($deepCopy = false) 
    {
        $copyObj = new Author();
        $copyObj->setFirstName($this->first_name);
        $copyObj->setLastName($this->last_name);

        if ($deepCopy) {        
            // important: setNew(false) because this affects the behavior of
            // the getter/setter methods for fkey referrer objects.
            $copyObj->setNew(false);

            foreach($this->getBooks() as $relObj) {
                $copyObj->addBook($relObj->copy());
            }
        } // if ($deepCopy)
        
        $copyObj->setNew(true);
        
        $copyObj->setAuthorId(NULL); // this is a pkey column, so set to default value

        return $copyObj;
    }
        

    /**
     * returns a peer instance associated with this om.  Since Peer classes    
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     * @return AuthorPeer
     */
    public function getPeer()
    {
        if (self::$peer === null) {
            self::$peer = new AuthorPeer();
        }
        return self::$peer;
    }

}