<?php 

require_once 'propel/om/BaseObject.php';

require_once 'propel/om/Persistent.php';
 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'bookstore/Publisher.php';
// (on-demand) include_once 'bookstore/PublisherPeer.php';
 

// (on-demand) include_once 'bookstore/Author.php';
// (on-demand) include_once 'bookstore/AuthorPeer.php';

include_once 'bookstore/BookPeer.php';

/**
 * Base class that represents a row from the 'book' table.
 *
 * Book Table *
 * This class was autogenerated by Propel on:
 *
 * [02/20/05 19:50:56]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Book class. 
 * 
 * @package bookstore 
 */
abstract class BaseBook extends BaseObject implements Persistent {
    
    /** 
     * The Peer class.
     * Instance provides a convenient way of calling static methods on a class
     * that calling code may not be able to identify.
     * @var BookPeer
     */
    protected static $peer;

    /**
     * The value for the book_id field.
     * @var int      
     */
    protected $book_id;    

    /**
     * The value for the title field.
     * @var string      
     */
    protected $title;    

    /**
     * The value for the isbn field.
     * @var string      
     */
    protected $isbn;    

    /**
     * The value for the publisher_id field.
     * @var int      
     */
    protected $publisher_id;    

    /**
     * The value for the author_id field.
     * @var int      
     */
    protected $author_id;    
  
    /**
     * Get the BookId column value.
     * Book Id     * @return int      
     */
    public function getBookId()
    {
        return $this->book_id;
    }


    /**
     * Set the value of `book_id` column.      
     * Book Id     * @param int $v new value
     * @return void
     * @throws PropelException 
     */
    public function setBookId($v)
    {
        if ($this->book_id !== $v) {
            $this->book_id = $v;
            $this->modifiedColumns[] = BookPeer::BOOK_ID;
        }
            
          // update associated Review          
          if ($this->collReviews !== null) {
              for ($i=0,$size=count($this->collReviews); $i < $size; $i++) {
                  $this->collReviews[$i]->setBookId($v);
              }
          }
                  
          // update associated Media          
          if ($this->collMedias !== null) {
              for ($i=0,$size=count($this->collMedias); $i < $size; $i++) {
                  $this->collMedias[$i]->setBookId($v);
              }
          }
                      
    }

  
    /**
     * Get the Title column value.
     * Book Title     * @return string      
     */
    public function getTitle()
    {
        return $this->title;
    }


    /**
     * Set the value of `title` column.      
     * Book Title     * @param string $v new value
     * @return void
     *  
     */
    public function setTitle($v)
    {
        if ($this->title !== $v) {
            $this->title = $v;
            $this->modifiedColumns[] = BookPeer::TITLE;
        }
                
    }

  
    /**
     * Get the ISBN column value.
     * ISBN Number     * @return string      
     */
    public function getISBN()
    {
        return $this->isbn;
    }


    /**
     * Set the value of `isbn` column.      
     * ISBN Number     * @param string $v new value
     * @return void
     *  
     */
    public function setISBN($v)
    {
        if ($this->isbn !== $v) {
            $this->isbn = $v;
            $this->modifiedColumns[] = BookPeer::ISBN;
        }
                
    }

  
    /**
     * Get the PublisherId column value.
     * Foreign Key Publisher     * @return int      
     */
    public function getPublisherId()
    {
        return $this->publisher_id;
    }


    /**
     * Set the value of `publisher_id` column.      
     * Foreign Key Publisher     * @param int $v new value
     * @return void
     * @throws PropelException 
     */
    public function setPublisherId($v)
    {
        if ($this->publisher_id !== $v) {
            $this->publisher_id = $v;
            $this->modifiedColumns[] = BookPeer::PUBLISHER_ID;
        }
            
        if ($this->aPublisher !== null && $this->aPublisher->getPublisherId() !== $v) {
            $this->aPublisher = null;
        }
            
    }

  
    /**
     * Get the AuthorId column value.
     * Foreign Key Author     * @return int      
     */
    public function getAuthorId()
    {
        return $this->author_id;
    }


    /**
     * Set the value of `author_id` column.      
     * Foreign Key Author     * @param int $v new value
     * @return void
     * @throws PropelException 
     */
    public function setAuthorId($v)
    {
        if ($this->author_id !== $v) {
            $this->author_id = $v;
            $this->modifiedColumns[] = BookPeer::AUTHOR_ID;
        }
            
        if ($this->aAuthor !== null && $this->aAuthor->getAuthorId() !== $v) {
            $this->aAuthor = null;
        }
            
    }


    
    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (1-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
     * @param int $startcol 1-based offset column which indicates which restultset column to start with.
     * @return void
     * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate(ResultSet $rs, $startcol = 1)
    {
        try {
            $this->book_id = $rs->getInt($startcol + 0);                    
            $this->title = $rs->getString($startcol + 1);                    
            $this->isbn = $rs->getString($startcol + 2);                    
            $this->publisher_id = $rs->getInt($startcol + 3);                    
            $this->author_id = $rs->getInt($startcol + 4);                    
             
            $this->resetModified();
            $this->setNew(false);
        
        } catch (Exception $e) {
            throw new PropelException("Error populating object", $e);
        }        
    
    }
    
    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether or not they have been modified.
     * 
     * @return Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria()
    {        
        $criteria = new Criteria(BookPeer::DATABASE_NAME);
        $criteria->add(BookPeer::BOOK_ID, $this->book_id);
        return $criteria;            
    }
    
    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria()
    {        
        $criteria = new Criteria(BookPeer::DATABASE_NAME);
        if ($this->isColumnModified(BookPeer::BOOK_ID)) $criteria->add(BookPeer::BOOK_ID, $this->book_id);
        if ($this->isColumnModified(BookPeer::TITLE)) $criteria->add(BookPeer::TITLE, $this->title);
        if ($this->isColumnModified(BookPeer::ISBN)) $criteria->add(BookPeer::ISBN, $this->isbn);
        if ($this->isColumnModified(BookPeer::PUBLISHER_ID)) $criteria->add(BookPeer::PUBLISHER_ID, $this->publisher_id);
        if ($this->isColumnModified(BookPeer::AUTHOR_ID)) $criteria->add(BookPeer::AUTHOR_ID, $this->author_id);
        return $criteria;            
    }
    
    

    /**
     * @var Publisher      
     */
    protected $aPublisher;

    /**
     * Declares an association between this object and a Publisher object
     *
     * @param Publisher $v
     * @return void
     * @throws PropelException
     */
    public function setPublisher($v)
    {
            
        if ($v === null) {
            $this->setPublisherId(NULL);
        } else {
            $this->setPublisherId($v->getPublisherId());
        }
   
        $this->aPublisher = $v;
    }


    /**
     * Get the associated Publisher object
     *
     * @param Connection Optional Connection object.
     * @return Publisher The associated Publisher object.
     * @throws PropelException
     */
    public function getPublisher($con = null)
    {
        // include the Peer class
        include_once 'bookstore/PublisherPeer.php';

        if ($this->aPublisher === null && ($this->publisher_id !== null)) {
    
            $this->aPublisher = PublisherPeer::retrieveByPK($this->publisher_id, $con);
    
            /* The following can be used instead of the line above to
               guarantee the related object contains a reference
               to this object, but this level of coupling
               may be undesirable in many circumstances.
               As it can lead to a db query with many results that may
               never be used.
               $obj = PublisherPeer::retrieveByPK($this->publisher_id, $con);
               $obj->addBooks($this);
             */
        }
        return $this->aPublisher;
    }

    /**
     * Provides convenient way to set a relationship based on a
     * key.  e.g.
     * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
     *
 
     * @return void
     * @throws PropelException
     */
    public function setPublisherKey($key)
    {

        $this->setPublisherId( (int) $key);            
        
    }

    /**
     * @var Author      
     */
    protected $aAuthor;

    /**
     * Declares an association between this object and a Author object
     *
     * @param Author $v
     * @return void
     * @throws PropelException
     */
    public function setAuthor($v)
    {
            
        if ($v === null) {
            $this->setAuthorId(NULL);
        } else {
            $this->setAuthorId($v->getAuthorId());
        }
   
        $this->aAuthor = $v;
    }


    /**
     * Get the associated Author object
     *
     * @param Connection Optional Connection object.
     * @return Author The associated Author object.
     * @throws PropelException
     */
    public function getAuthor($con = null)
    {
        // include the Peer class
        include_once 'bookstore/AuthorPeer.php';

        if ($this->aAuthor === null && ($this->author_id !== null)) {
    
            $this->aAuthor = AuthorPeer::retrieveByPK($this->author_id, $con);
    
            /* The following can be used instead of the line above to
               guarantee the related object contains a reference
               to this object, but this level of coupling
               may be undesirable in many circumstances.
               As it can lead to a db query with many results that may
               never be used.
               $obj = AuthorPeer::retrieveByPK($this->author_id, $con);
               $obj->addBooks($this);
             */
        }
        return $this->aAuthor;
    }

    /**
     * Provides convenient way to set a relationship based on a
     * key.  e.g.
     * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
     *
 
     * @return void
     * @throws PropelException
     */
    public function setAuthorKey($key)
    {

        $this->setAuthorId( (int) $key);            
        
    }

    /**
     * Collection to store aggregation of collReviews      
     * @var array
     */
    protected $collReviews; 

    /**
     * Temporary storage of collReviews to save a possible db hit in
     * the event objects are add to the collection, but the
     * complete collection is never requested.
     * @return void
     */
    public function initReviews()
    {
        if ($this->collReviews === null) {
            $this->collReviews = array();
        }
    }

    /**
     * Method called to associate a Review object to this object
     * through the Review foreign key attribute
     *
     * @param Review $l $className
     * @return void
     * @throws PropelException
     */
    public function addReview(Review $l)
    {
        $this->collReviews[] = $l;
        $l->setBook($this);
    }

    /**
     * The criteria used to select the current contents of collReviews.
     * @var Criteria
     */
    private $lastReviewsCriteria = null;

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Book has previously
     * been saved, it will retrieve related Reviews from storage.
     * If this Book is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @param Connection $con
     * @param Criteria $criteria
     * @throws PropelException
     */
    public function getReviews($criteria = null, $con = null)
    {
        // include the Peer class
        include_once 'bookstore/ReviewPeer.php';
        if ($criteria === null) {
            $criteria = new Criteria();
        }
                
        if ($this->collReviews === null) {
            if ($this->isNew()) {
               $this->collReviews = array();
            } else {
    
                $criteria->add(ReviewPeer::BOOK_ID, $this->getBookId() );

                $this->collReviews = ReviewPeer::doSelect($criteria, $con);
            }
        } else {
            // criteria has no effect for a new object
            if (!$this->isNew()) {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.

                $criteria->add(ReviewPeer::BOOK_ID, $this->getBookId());

                if (!isset($this->lastReviewsCriteria) || !$this->lastReviewsCriteria->equals($criteria)) {
                    $this->collReviews = ReviewPeer::doSelect($criteria, $con);
                }
            }
        }
        $this->lastReviewsCriteria = $criteria;

        return $this->collReviews;
    }
    

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Book is new, it will return
     * an empty collection; or if this Book has previously
     * been saved, it will retrieve related Reviews from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in Book.
     */
    public function getReviewsJoinBook($criteria = null, $con = null)
    {
        if ($criteria === null) {
            $criteria = new Criteria();
        }
        
        if ($this->collReviews === null) {
            if ($this->isNew()) {
               $this->collReviews = array();
            } else {
       
                $criteria->add(ReviewPeer::BOOK_ID, $this->getBookId());
                $this->collReviews = ReviewPeer::doSelectJoinBook($criteria, $con);
            }
        } else {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
      
            $criteria->add(ReviewPeer::BOOK_ID, $this->getBookId());
            if (!isset($this->lastReviewsCriteria) || !$this->lastReviewsCriteria->equals($criteria)) {
                $this->collReviews = ReviewPeer::doSelectJoinBook($criteria, $con);
            }
        }
        $this->lastReviewsCriteria = $criteria;

        return $this->collReviews;
    }

    /**
     * Collection to store aggregation of collMedias      
     * @var array
     */
    protected $collMedias; 

    /**
     * Temporary storage of collMedias to save a possible db hit in
     * the event objects are add to the collection, but the
     * complete collection is never requested.
     * @return void
     */
    public function initMedias()
    {
        if ($this->collMedias === null) {
            $this->collMedias = array();
        }
    }

    /**
     * Method called to associate a Media object to this object
     * through the Media foreign key attribute
     *
     * @param Media $l $className
     * @return void
     * @throws PropelException
     */
    public function addMedia(Media $l)
    {
        $this->collMedias[] = $l;
        $l->setBook($this);
    }

    /**
     * The criteria used to select the current contents of collMedias.
     * @var Criteria
     */
    private $lastMediasCriteria = null;

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Book has previously
     * been saved, it will retrieve related Medias from storage.
     * If this Book is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @param Connection $con
     * @param Criteria $criteria
     * @throws PropelException
     */
    public function getMedias($criteria = null, $con = null)
    {
        // include the Peer class
        include_once 'bookstore/MediaPeer.php';
        if ($criteria === null) {
            $criteria = new Criteria();
        }
                
        if ($this->collMedias === null) {
            if ($this->isNew()) {
               $this->collMedias = array();
            } else {
    
                $criteria->add(MediaPeer::BOOK_ID, $this->getBookId() );

                $this->collMedias = MediaPeer::doSelect($criteria, $con);
            }
        } else {
            // criteria has no effect for a new object
            if (!$this->isNew()) {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.

                $criteria->add(MediaPeer::BOOK_ID, $this->getBookId());

                if (!isset($this->lastMediasCriteria) || !$this->lastMediasCriteria->equals($criteria)) {
                    $this->collMedias = MediaPeer::doSelect($criteria, $con);
                }
            }
        }
        $this->lastMediasCriteria = $criteria;

        return $this->collMedias;
    }
    

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Book is new, it will return
     * an empty collection; or if this Book has previously
     * been saved, it will retrieve related Medias from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in Book.
     */
    public function getMediasJoinBook($criteria = null, $con = null)
    {
        if ($criteria === null) {
            $criteria = new Criteria();
        }
        
        if ($this->collMedias === null) {
            if ($this->isNew()) {
               $this->collMedias = array();
            } else {
       
                $criteria->add(MediaPeer::BOOK_ID, $this->getBookId());
                $this->collMedias = MediaPeer::doSelectJoinBook($criteria, $con);
            }
        } else {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
      
            $criteria->add(MediaPeer::BOOK_ID, $this->getBookId());
            if (!isset($this->lastMediasCriteria) || !$this->lastMediasCriteria->equals($criteria)) {
                $this->collMedias = MediaPeer::doSelectJoinBook($criteria, $con);
            }
        }
        $this->lastMediasCriteria = $criteria;

        return $this->collMedias;
    }



 
    /**
     * Removes this object from datastore and sets delete attribute.
     * 
     * @param Connection $con
     * @return void
     * @throws PropelException
     * @see BaseObject::setDeleted()
     * @see BaseObject::isDeleted()
     */
    public function delete($con = null)
    {    
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }
        
        if ($con === null)
            $con = Propel::getConnection(BookPeer::DATABASE_NAME);

        try {
            $con->begin();
            BookPeer::doDelete($this, $con);
            $this->setDeleted(true);
            $con->commit();
        } catch (PropelException $e) {
            $con->rollback();
            throw $e;
        }
    }
    

    /**
     * flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var boolean
     */
    private $alreadyInSave = false;

    /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.  This method
     * wraps the doSave() worker method in a transaction.
     *
     * @param Connection $con
     * @return void
     * @throws PropelException
     */
    public function save($con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }
        
        if ($con === null)
            $con = Propel::getConnection(BookPeer::DATABASE_NAME);

        try {
            $con->begin();
            $this->doSave($con);            
            $con->commit();
        } catch (PropelException $e) {
            $con->rollback();
            throw $e;
        }
    }
  
    /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.
     *
     * @param Connection $con
     * @return void
     * @throws PropelException
     */
		protected function doSave($con)    { 
        
     
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            // We call the save method on the following object(s) if they
            // were passed to this object by their coresponding set
            // method.  This object relates to these object(s) by a
            // foreign key reference.
 
            if ($this->aPublisher !== null) {
                if ($this->aPublisher->isModified()) $this->aPublisher->save($con);
                $this->setPublisher($this->aPublisher);
            }
 
            if ($this->aAuthor !== null) {
                if ($this->aAuthor->isModified()) $this->aAuthor->save($con);
                $this->setAuthor($this->aAuthor);
            }

            // If this object has been modified, then save it to the database.
            if ($this->isModified()) {
                if ($this->isNew()) {
                    $pk = BookPeer::doInsert($this, $con);
					$this->setBookId( $pk );  //[IMV] update autoincrement primary key
                    $this->setNew(false);
                } else {
                    BookPeer::doUpdate($this, $con);
                }            
                $this->resetModified(); // [HL] After being saved an object is no longer 'modified'
            }
            if ($this->collReviews !== null) {
                for ($i=0,$size=count($this->collReviews); $i < $size; $i++) {
                    $this->collReviews[$i]->save($con);
                }
              }
            if ($this->collMedias !== null) {
                for ($i=0,$size=count($this->collMedias); $i < $size; $i++) {
                    $this->collMedias[$i]->save($con);
                }
              }

            $this->alreadyInSave = false;
        }
    }

    /**
     * Validates the objects modified field values.
     * This includes all objects related to this table.
     *
     * @return mixed <code>true</code> if all columns pass validation
     *              or an array of <code>ValidationFailed</code> objects for columns that fail.
     */
    public function validate()
    {
        return $this->doValidate();
    }

    /**
     * flag to prevent endless validation loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var boolean
     */
    protected $alreadyInValidation = false;
  
    /**
     * This function performs the validation work for complex object models.
     * 
     * In addition to checking the current object, all related objects will
     * also be validated.  If all pass then <code>true</code> is returned; otherwise
     * an aggreagated array of ValidationFailed objects will be returned.
     *
     * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
     */
    protected function doValidate()
    {
        if (! $this->alreadyInValidation) {
            $this->alreadyInValidation = true;
            $retval = null;
      
            $failureMap = array();      
      
            // We call the validate method on the following object(s) if they
            // were passed to this object by their coresponding set
            // method.  This object relates to these object(s) by a
            // foreign key reference.
            if ($this->aPublisher !== null) {
                if (($retval = $this->aPublisher->validate()) !== true) {
                    $failureMap = array_merge($failureMap, $retval);
                }
            }
            if ($this->aAuthor !== null) {
                if (($retval = $this->aAuthor->validate()) !== true) {
                    $failureMap = array_merge($failureMap, $retval);
                }
            }

            if (($retval = BookPeer::doValidate($this)) !== true) {
                $failureMap = array_merge($failureMap, $retval);
            }
      
            if ($this->collReviews !== null) {
                for ($i=0,$size=count($this->collReviews); $i < $size; $i++) {
                    if (($retval = $this->collReviews[$i]->validate()) !== true) {
                        $failureMap = array_merge($failureMap, $retval);
                    }
                }
            }
            if ($this->collMedias !== null) {
                for ($i=0,$size=count($this->collMedias); $i < $size; $i++) {
                    if (($retval = $this->collMedias[$i]->validate()) !== true) {
                        $failureMap = array_merge($failureMap, $retval);
                    }
                }
            }
      
            $this->alreadyInValidation = false;
        }
    
        return (!empty($failureMap) ? $failureMap : true);
    }
  

    /**
     * Set the PrimaryKey.
     *
     * @param mixed book_id Primary key.
     * @return void
     * @throws PropelException     */
    public function setPrimaryKey($key) 
    {        
        $this->setBookId($key);
    }
    

    /**
     * Returns an id that differentiates this object from others
     * of its class.
     * @return int 
     */
    public function getPrimaryKey()
    {

        return $this->getBookId();

    }

    
    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *  
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     *  
     * @return Book Clone of current object.
     * @throws PropelException
     */
    public function copy($deepCopy = false) 
    {
        $copyObj = new Book();
        $copyObj->setTitle($this->title);
        $copyObj->setISBN($this->isbn);
        $copyObj->setPublisherId($this->publisher_id);
        $copyObj->setAuthorId($this->author_id);

        if ($deepCopy) {        
            // important: setNew(false) because this affects the behavior of
            // the getter/setter methods for fkey referrer objects.
            $copyObj->setNew(false);

            foreach($this->getReviews() as $relObj) {
                $copyObj->addReview($relObj->copy());
            }

            foreach($this->getMedias() as $relObj) {
                $copyObj->addMedia($relObj->copy());
            }
        } // if ($deepCopy)
        
        $copyObj->setNew(true);
        
        $copyObj->setBookId(NULL); // this is a pkey column, so set to default value

        return $copyObj;
    }
        

    /**
     * returns a peer instance associated with this om.  Since Peer classes    
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     * @return BookPeer
     */
    public function getPeer()
    {
        if (self::$peer === null) {
            self::$peer = new BookPeer();
        }
        return self::$peer;
    }

}