<?php 

require_once 'propel/om/BaseObject.php';

require_once 'propel/om/Persistent.php';
 
include_once 'creole/util/Clob.php';
include_once 'creole/util/Blob.php';
 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'bookstore/Book.php';
// (on-demand) include_once 'bookstore/BookPeer.php';

include_once 'bookstore/MediaPeer.php';

/**
 * Base class that represents a row from the 'media' table.
 *
 *  *
 * This class was autogenerated by Propel on:
 *
 * [02/20/05 19:50:56]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Media class. 
 * 
 * @package bookstore 
 */
abstract class BaseMedia extends BaseObject implements Persistent {
    
    /** 
     * The Peer class.
     * Instance provides a convenient way of calling static methods on a class
     * that calling code may not be able to identify.
     * @var MediaPeer
     */
    protected static $peer;

    /**
     * The value for the media_id field.
     * @var int      
     */
    protected $media_id;    

    /**
     * The value for the cover_image field.
     * @var string      
     */
    protected $cover_image;    
    
    /**
     * Whether the lazy-loaded cover_image value has been loaded from database.
     * This is necessary to avoid repeated lookups if cover_image column is NULL.
     * @var boolean
     */
    protected $cover_image_isLoaded = false;

    /**
     * The value for the excerpt field.
     * @var string      
     */
    protected $excerpt;    
    
    /**
     * Whether the lazy-loaded excerpt value has been loaded from database.
     * This is necessary to avoid repeated lookups if excerpt column is NULL.
     * @var boolean
     */
    protected $excerpt_isLoaded = false;

    /**
     * The value for the book_id field.
     * @var int      
     */
    protected $book_id;    
  
    /**
     * Get the MediaId column value.
     * Media Id     * @return int      
     */
    public function getMediaId()
    {
        return $this->media_id;
    }


    /**
     * Set the value of `media_id` column.      
     * Media Id     * @param int $v new value
     * @return void
     *  
     */
    public function setMediaId($v)
    {
        if ($this->media_id !== $v) {
            $this->media_id = $v;
            $this->modifiedColumns[] = MediaPeer::MEDIA_ID;
        }
                
    }

  
    /**
     * Get the CoverImage column value.
     * The image of the book cover.     * @return string      
     */
    public function getCoverImage($con = null)
    {
        if (!$this->cover_image_isLoaded && $this->cover_image === null) {
            $this->loadCoverImage($con);
        }
        return $this->cover_image;
    }

    /**
     * Load the value for the [lazy-load] `cover_image` column.
     *
     * This method performs an additional query to return the value for
     * the `cover_image` column, since it is not populated by
     * the hydrate() method.
     *
     * @param Connection
     * @return void
     * @throws PropelException - any underlying error will be wrapped and re-thrown.
     */
    protected function loadCoverImage($con = null)
    {
        $c = $this->buildPkeyCriteria();
        $c->addSelectColumn(MediaPeer::COVER_IMAGE);
        try {
            $rs = MediaPeer::doSelectRS($c, $con);
            $rs->next();
            $this->cover_image = $rs->getBlob(1);
            $this->cover_image_isLoaded = true;
        } catch (Exception $e) {
            throw new PropelException("Error loading value for `cover_image` column on demand.", $e);
        }
    }


    /**
     * Set the value of `cover_image` column.      
     * The image of the book cover.     * @param string $v new value
     * @return void
     *  
     */
    public function setCoverImage($v)
    {
        // explicitly set the is-loaded flag to true for this lazy load col; 
        // it doesn't matter if the value is actually set or not (logic below) as
        // any attempt to set the value means that no db lookup should be performed
        // when the getCoverImage() method is called. 
        $this->cover_image_isLoaded = true;
        // if the passed in parameter is the *same* object that
        // is stored internally then we use the Lob->isModified() 
        // method to know whether contents changed.
        if ($v instanceof Lob && $v === $this->cover_image) {
            $changed = $v->isModified();
        } else {
            $changed = ($this->cover_image !== $v);
        }                
        if ($changed) {
            if ( !($v instanceof Lob) ) {
                $obj = new Blob();
                $obj->setContents($v);
            } else {
                $obj = $v;
            }
            $this->cover_image = $obj;        
            $this->modifiedColumns[] = MediaPeer::COVER_IMAGE;
        }
        
    }

  
    /**
     * Get the Excerpt column value.
     * An excerpt from the book.     * @return string      
     */
    public function getExcerpt($con = null)
    {
        if (!$this->excerpt_isLoaded && $this->excerpt === null) {
            $this->loadExcerpt($con);
        }
        return $this->excerpt;
    }

    /**
     * Load the value for the [lazy-load] `excerpt` column.
     *
     * This method performs an additional query to return the value for
     * the `excerpt` column, since it is not populated by
     * the hydrate() method.
     *
     * @param Connection
     * @return void
     * @throws PropelException - any underlying error will be wrapped and re-thrown.
     */
    protected function loadExcerpt($con = null)
    {
        $c = $this->buildPkeyCriteria();
        $c->addSelectColumn(MediaPeer::EXCERPT);
        try {
            $rs = MediaPeer::doSelectRS($c, $con);
            $rs->next();
            $this->excerpt = $rs->getClob(1);
            $this->excerpt_isLoaded = true;
        } catch (Exception $e) {
            throw new PropelException("Error loading value for `excerpt` column on demand.", $e);
        }
    }


    /**
     * Set the value of `excerpt` column.      
     * An excerpt from the book.     * @param string $v new value
     * @return void
     *  
     */
    public function setExcerpt($v)
    {
        // explicitly set the is-loaded flag to true for this lazy load col; 
        // it doesn't matter if the value is actually set or not (logic below) as
        // any attempt to set the value means that no db lookup should be performed
        // when the getExcerpt() method is called. 
        $this->excerpt_isLoaded = true;
        // if the passed in parameter is the *same* object that
        // is stored internally then we use the Lob->isModified() 
        // method to know whether contents changed.
        if ($v instanceof Lob && $v === $this->excerpt) {
            $changed = $v->isModified();
        } else {
            $changed = ($this->excerpt !== $v);
        }                
        if ($changed) {
            if ( !($v instanceof Lob) ) {
                $obj = new Clob();
                $obj->setContents($v);
            } else {
                $obj = $v;
            }
            $this->excerpt = $obj;        
            $this->modifiedColumns[] = MediaPeer::EXCERPT;
        }
        
    }

  
    /**
     * Get the BookId column value.
     * Book ID for this media collection.     * @return int      
     */
    public function getBookId()
    {
        return $this->book_id;
    }


    /**
     * Set the value of `book_id` column.      
     * Book ID for this media collection.     * @param int $v new value
     * @return void
     * @throws PropelException 
     */
    public function setBookId($v)
    {
        if ($this->book_id !== $v) {
            $this->book_id = $v;
            $this->modifiedColumns[] = MediaPeer::BOOK_ID;
        }
            
        if ($this->aBook !== null && $this->aBook->getBookId() !== $v) {
            $this->aBook = null;
        }
            
    }


    
    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (1-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
     * @param int $startcol 1-based offset column which indicates which restultset column to start with.
     * @return void
     * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate(ResultSet $rs, $startcol = 1)
    {
        try {
            $this->media_id = $rs->getInt($startcol + 0);                    
            $this->book_id = $rs->getInt($startcol + 1);                    
             
            $this->resetModified();
            $this->setNew(false);
        
        } catch (Exception $e) {
            throw new PropelException("Error populating object", $e);
        }        
    
    }
    
    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether or not they have been modified.
     * 
     * @return Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria()
    {        
        $criteria = new Criteria(MediaPeer::DATABASE_NAME);
        $criteria->add(MediaPeer::MEDIA_ID, $this->media_id);
        return $criteria;            
    }
    
    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria()
    {        
        $criteria = new Criteria(MediaPeer::DATABASE_NAME);
        if ($this->isColumnModified(MediaPeer::MEDIA_ID)) $criteria->add(MediaPeer::MEDIA_ID, $this->media_id);
        if ($this->isColumnModified(MediaPeer::COVER_IMAGE)) $criteria->add(MediaPeer::COVER_IMAGE, $this->cover_image);
        if ($this->isColumnModified(MediaPeer::EXCERPT)) $criteria->add(MediaPeer::EXCERPT, $this->excerpt);
        if ($this->isColumnModified(MediaPeer::BOOK_ID)) $criteria->add(MediaPeer::BOOK_ID, $this->book_id);
        return $criteria;            
    }
    
    

    /**
     * @var Book      
     */
    protected $aBook;

    /**
     * Declares an association between this object and a Book object
     *
     * @param Book $v
     * @return void
     * @throws PropelException
     */
    public function setBook($v)
    {
            
        if ($v === null) {
            $this->setBookId(NULL);
        } else {
            $this->setBookId($v->getBookId());
        }
   
        $this->aBook = $v;
    }


    /**
     * Get the associated Book object
     *
     * @param Connection Optional Connection object.
     * @return Book The associated Book object.
     * @throws PropelException
     */
    public function getBook($con = null)
    {
        // include the Peer class
        include_once 'bookstore/BookPeer.php';

        if ($this->aBook === null && ($this->book_id !== null)) {
    
            $this->aBook = BookPeer::retrieveByPK($this->book_id, $con);
    
            /* The following can be used instead of the line above to
               guarantee the related object contains a reference
               to this object, but this level of coupling
               may be undesirable in many circumstances.
               As it can lead to a db query with many results that may
               never be used.
               $obj = BookPeer::retrieveByPK($this->book_id, $con);
               $obj->addMedias($this);
             */
        }
        return $this->aBook;
    }

    /**
     * Provides convenient way to set a relationship based on a
     * key.  e.g.
     * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
     *
 
     * @return void
     * @throws PropelException
     */
    public function setBookKey($key)
    {

        $this->setBookId( (int) $key);            
        
    }



 
    /**
     * Removes this object from datastore and sets delete attribute.
     * 
     * @param Connection $con
     * @return void
     * @throws PropelException
     * @see BaseObject::setDeleted()
     * @see BaseObject::isDeleted()
     */
    public function delete($con = null)
    {    
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }
        
        if ($con === null)
            $con = Propel::getConnection(MediaPeer::DATABASE_NAME);

        try {
            $con->begin();
            MediaPeer::doDelete($this, $con);
            $this->setDeleted(true);
            $con->commit();
        } catch (PropelException $e) {
            $con->rollback();
            throw $e;
        }
    }
    

    /**
     * flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var boolean
     */
    private $alreadyInSave = false;

    /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.  This method
     * wraps the doSave() worker method in a transaction.
     *
     * @param Connection $con
     * @return void
     * @throws PropelException
     */
    public function save($con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }
        
        if ($con === null)
            $con = Propel::getConnection(MediaPeer::DATABASE_NAME);

        try {
            $con->begin();
            $this->doSave($con);            
            $con->commit();
        } catch (PropelException $e) {
            $con->rollback();
            throw $e;
        }
    }
  
    /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.
     *
     * @param Connection $con
     * @return void
     * @throws PropelException
     */
		protected function doSave($con)    { 
        
     
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            // We call the save method on the following object(s) if they
            // were passed to this object by their coresponding set
            // method.  This object relates to these object(s) by a
            // foreign key reference.
 
            if ($this->aBook !== null) {
                if ($this->aBook->isModified()) $this->aBook->save($con);
                $this->setBook($this->aBook);
            }

            // If this object has been modified, then save it to the database.
            if ($this->isModified()) {
                if ($this->isNew()) {
                    $pk = MediaPeer::doInsert($this, $con);
					$this->setMediaId( $pk );  //[IMV] update autoincrement primary key
                    $this->setNew(false);
                } else {
                    MediaPeer::doUpdate($this, $con);
                }            
                $this->resetModified(); // [HL] After being saved an object is no longer 'modified'
            }

            $this->alreadyInSave = false;
        }
    }

    /**
     * Validates the objects modified field values.
     * This includes all objects related to this table.
     *
     * @return mixed <code>true</code> if all columns pass validation
     *              or an array of <code>ValidationFailed</code> objects for columns that fail.
     */
    public function validate()
    {
        return $this->doValidate();
    }

    /**
     * flag to prevent endless validation loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var boolean
     */
    protected $alreadyInValidation = false;
  
    /**
     * This function performs the validation work for complex object models.
     * 
     * In addition to checking the current object, all related objects will
     * also be validated.  If all pass then <code>true</code> is returned; otherwise
     * an aggreagated array of ValidationFailed objects will be returned.
     *
     * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
     */
    protected function doValidate()
    {
        if (! $this->alreadyInValidation) {
            $this->alreadyInValidation = true;
            $retval = null;
      
            $failureMap = array();      
      
            // We call the validate method on the following object(s) if they
            // were passed to this object by their coresponding set
            // method.  This object relates to these object(s) by a
            // foreign key reference.
            if ($this->aBook !== null) {
                if (($retval = $this->aBook->validate()) !== true) {
                    $failureMap = array_merge($failureMap, $retval);
                }
            }

            if (($retval = MediaPeer::doValidate($this)) !== true) {
                $failureMap = array_merge($failureMap, $retval);
            }
      
      
            $this->alreadyInValidation = false;
        }
    
        return (!empty($failureMap) ? $failureMap : true);
    }
  

    /**
     * Set the PrimaryKey.
     *
     * @param mixed media_id Primary key.
     * @return void
     * @throws PropelException     */
    public function setPrimaryKey($key) 
    {        
        $this->setMediaId($key);
    }
    

    /**
     * Returns an id that differentiates this object from others
     * of its class.
     * @return int 
     */
    public function getPrimaryKey()
    {

        return $this->getMediaId();

    }

    
    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *  
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     *  
     * @return Media Clone of current object.
     * @throws PropelException
     */
    public function copy($deepCopy = false) 
    {
        $copyObj = new Media();
        $copyObj->setCoverImage($this->cover_image);
        $copyObj->setExcerpt($this->excerpt);
        $copyObj->setBookId($this->book_id);
        
        $copyObj->setNew(true);
        
        $copyObj->setMediaId(NULL); // this is a pkey column, so set to default value

        return $copyObj;
    }
        

    /**
     * returns a peer instance associated with this om.  Since Peer classes    
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     * @return MediaPeer
     */
    public function getPeer()
    {
        if (self::$peer === null) {
            self::$peer = new MediaPeer();
        }
        return self::$peer;
    }

}