<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'contact' table to 'PHPARCH' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 *  This class was autogenerated by Propel on:
 *
 * [05/11/05 20:21:01]
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package PHPARCH.map
 */
class ContactMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "PHPARCH.map.ContactMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("PHPARCH");
		
		$tMap = $this->dbMap->addTable("contact");
		$tMap->setPhpName("Contact");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("CONTACT_ID", "ContactId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("ACCOUNT_ID", "AccountId", "int", CreoleTypes::INTEGER, "account" , "ACCOUNT_ID", true);
		$tMap->addColumn("FIRST_NAME", "FirstName", "string", CreoleTypes::VARCHAR, false, 30);
		$tMap->addColumn("LAST_NAME", "LastName", "string", CreoleTypes::VARCHAR, false, 30);
		$tMap->addColumn("NICK_NAME", "NickName", "string", CreoleTypes::VARCHAR, false, 30);
		$tMap->addColumn("PRIMARY_EMAIL", "PrimaryEmail", "string", CreoleTypes::VARCHAR, false, 75);
		$tMap->addColumn("SECONDARY_EMAIL", "SecondaryEmail", "string", CreoleTypes::VARCHAR, false, 75);
		$tMap->addColumn("HOME_NUMBER", "HomeNumber", "string", CreoleTypes::VARCHAR, false, 10);
		$tMap->addColumn("WORK_NUMBER", "WorkNumber", "string", CreoleTypes::VARCHAR, false, 10);
		$tMap->addColumn("FAX_NUMBER", "FaxNumber", "string", CreoleTypes::VARCHAR, false, 10);
		$tMap->addColumn("MOBILE_NUMBER", "MobileNumber", "string", CreoleTypes::VARCHAR, false, 10);
		$tMap->addColumn("PAGER_NUMBER", "PagerNumber", "string", CreoleTypes::VARCHAR, false, 10);
		$tMap->addForeignKey("HOME_ADDRESS_ID", "HomeAddressId", "int", CreoleTypes::INTEGER, "address" , "ADDRESS_ID", false);
		$tMap->addForeignKey("WORK_ADDRESS_ID", "WorkAddressId", "int", CreoleTypes::INTEGER, "address" , "ADDRESS_ID", false);
		$tMap->addColumn("BIRTH_DATE", "BirthDate", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("INTERNET_HOMPAGE", "InternetHompage", "string", CreoleTypes::VARCHAR, false, 75);
		$tMap->addColumn("NOTES", "Notes", "string", CreoleTypes::LONGVARCHAR, false, null);
				
    }
}
