<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'list_item' table to 'PHPARCH' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 *  This class was autogenerated by Propel on:
 *
 * [05/11/05 20:21:01]
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package PHPARCH.map
 */
class ListItemMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "PHPARCH.map.ListItemMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("PHPARCH");
		
		$tMap = $this->dbMap->addTable("list_item");
		$tMap->setPhpName("ListItem");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("ITEM_ID", "ItemId", "int", CreoleTypes::INTEGER, true);
		$tMap->addColumn("GROUP_NAME", "GroupName", "string", CreoleTypes::VARCHAR, true, 50);
		$tMap->addColumn("SHORT_NAME", "ShortName", "string", CreoleTypes::VARCHAR, true, 50);
		$tMap->addColumn("DESCRIPTION", "Description", "string", CreoleTypes::VARCHAR, false, 128);
		$tMap->addColumn("IS_ENABLED", "IsEnabled", "int", CreoleTypes::TINYINT, true, null);
		$tMap->addColumn("SORT_ORDER", "SortOrder", "int", CreoleTypes::SMALLINT, true, null);
				
    }
}
