<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';

include_once 'PHPARCH/AccountPeer.php';

/**
 * Base class that represents a row from the 'account' table.
 *
 *  
 *
 * This class was autogenerated by Propel on:
 *
 * [05/11/05 20:21:01]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Account class. 
 * 
 * @package PHPARCH 
 */
abstract class BaseAccount extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var AccountPeer
	 */
	protected static $peer;

	/**
	 * The value for the account_id field.
	 * @var int	  
	 */
	protected $account_id;	

	/**
	 * The value for the username field.
	 * @var string	  
	 */
	protected $username = '';	

	/**
	 * The value for the password field.
	 * @var string	  
	 */
	protected $password = '';	

	/**
	 * The value for the last_name field.
	 * @var string	  
	 */
	protected $last_name = '';	

	/**
	 * The value for the first_name field.
	 * @var string	  
	 */
	protected $first_name = '';	

	/**
	 * The value for the is_enabled field.
	 * @var int	  
	 */
	protected $is_enabled = 1;	

	/**
	 * The value for the is_admin field.
	 * @var int	  
	 */
	protected $is_admin = 0;	
  
	/**
	 * Get the AccountId column value.
	 *  
	 * @return int	  
	 */
	public function getAccountId()
	{
		return $this->account_id;
	}


	/**
	 * Set the value of `account_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setAccountId($v)
	{
		if ($this->account_id !== $v) {
			$this->account_id = $v;
			$this->modifiedColumns[] = AccountPeer::ACCOUNT_ID;
		}
			
		  // update associated Contact		  
		  if ($this->collContacts !== null) {
			  for ($i=0,$size=count($this->collContacts); $i < $size; $i++) {
				  $this->collContacts[$i]->setAccountId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the Username column value.
	 *  
	 * @return string	  
	 */
	public function getUsername()
	{
		return $this->username;
	}


	/**
	 * Set the value of `username` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setUsername($v)
	{
		if ($this->username !== $v || $v === '') {
			$this->username = $v;
			$this->modifiedColumns[] = AccountPeer::USERNAME;
		}
				
	}

  
	/**
	 * Get the Password column value.
	 *  
	 * @return string	  
	 */
	public function getPassword()
	{
		return $this->password;
	}


	/**
	 * Set the value of `password` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setPassword($v)
	{
		if ($this->password !== $v || $v === '') {
			$this->password = $v;
			$this->modifiedColumns[] = AccountPeer::PASSWORD;
		}
				
	}

  
	/**
	 * Get the LastName column value.
	 *  
	 * @return string	  
	 */
	public function getLastName()
	{
		return $this->last_name;
	}


	/**
	 * Set the value of `last_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setLastName($v)
	{
		if ($this->last_name !== $v || $v === '') {
			$this->last_name = $v;
			$this->modifiedColumns[] = AccountPeer::LAST_NAME;
		}
				
	}

  
	/**
	 * Get the FirstName column value.
	 *  
	 * @return string	  
	 */
	public function getFirstName()
	{
		return $this->first_name;
	}


	/**
	 * Set the value of `first_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setFirstName($v)
	{
		if ($this->first_name !== $v || $v === '') {
			$this->first_name = $v;
			$this->modifiedColumns[] = AccountPeer::FIRST_NAME;
		}
				
	}

  
	/**
	 * Get the IsEnabled column value.
	 *  
	 * @return int	  
	 */
	public function getIsEnabled()
	{
		return $this->is_enabled;
	}


	/**
	 * Set the value of `is_enabled` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setIsEnabled($v)
	{
		if ($this->is_enabled !== $v || $v === 1) {
			$this->is_enabled = $v;
			$this->modifiedColumns[] = AccountPeer::IS_ENABLED;
		}
				
	}

  
	/**
	 * Get the IsAdmin column value.
	 *  
	 * @return int	  
	 */
	public function getIsAdmin()
	{
		return $this->is_admin;
	}


	/**
	 * Set the value of `is_admin` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setIsAdmin($v)
	{
		if ($this->is_admin !== $v || $v === 0) {
			$this->is_admin = $v;
			$this->modifiedColumns[] = AccountPeer::IS_ADMIN;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->account_id = $rs->getInt($startcol + 0);					
			$this->username = $rs->getString($startcol + 1);					
			$this->password = $rs->getString($startcol + 2);					
			$this->last_name = $rs->getString($startcol + 3);					
			$this->first_name = $rs->getString($startcol + 4);					
			$this->is_enabled = $rs->getInt($startcol + 5);					
			$this->is_admin = $rs->getInt($startcol + 6);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating Account object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(AccountPeer::DATABASE_NAME);
		$criteria->add(AccountPeer::ACCOUNT_ID, $this->account_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(AccountPeer::DATABASE_NAME);
		if ($this->isColumnModified(AccountPeer::ACCOUNT_ID)) $criteria->add(AccountPeer::ACCOUNT_ID, $this->account_id);
		if ($this->isColumnModified(AccountPeer::USERNAME)) $criteria->add(AccountPeer::USERNAME, $this->username);
		if ($this->isColumnModified(AccountPeer::PASSWORD)) $criteria->add(AccountPeer::PASSWORD, $this->password);
		if ($this->isColumnModified(AccountPeer::LAST_NAME)) $criteria->add(AccountPeer::LAST_NAME, $this->last_name);
		if ($this->isColumnModified(AccountPeer::FIRST_NAME)) $criteria->add(AccountPeer::FIRST_NAME, $this->first_name);
		if ($this->isColumnModified(AccountPeer::IS_ENABLED)) $criteria->add(AccountPeer::IS_ENABLED, $this->is_enabled);
		if ($this->isColumnModified(AccountPeer::IS_ADMIN)) $criteria->add(AccountPeer::IS_ADMIN, $this->is_admin);
		return $criteria;			
	}
	
	

	/**
	 * Collection to store aggregation of collContacts	  
	 * @var array
	 */
	protected $collContacts; 

	/**
	 * Temporary storage of collContacts to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initContacts()
	{
		if ($this->collContacts === null) {
			$this->collContacts = array();
		}
	}

	/**
	 * Method called to associate a Contact object to this object
	 * through the Contact foreign key attribute
	 *
	 * @param Contact $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addContact(Contact $l)
	{
		$this->collContacts[] = $l;
		$l->setAccount($this);
	}

	/**
	 * The criteria used to select the current contents of collContacts.
	 * @var Criteria
	 */
	private $lastContactsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Account has previously
	 * been saved, it will retrieve related Contacts from storage.
	 * If this Account is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getContacts($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'PHPARCH/ContactPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collContacts === null) {
			if ($this->isNew()) {
			   $this->collContacts = array();
			} else {
	
				$criteria->add(ContactPeer::ACCOUNT_ID, $this->getAccountId() );

				$this->collContacts = ContactPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ContactPeer::ACCOUNT_ID, $this->getAccountId());

				if (!isset($this->lastContactsCriteria) || !$this->lastContactsCriteria->equals($criteria)) {
					$this->collContacts = ContactPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastContactsCriteria = $criteria;

		return $this->collContacts;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Account is new, it will return
	 * an empty collection; or if this Account has previously
	 * been saved, it will retrieve related Contacts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Account.
	 */
	public function getContactsJoinAccount($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'PHPARCH/ContactPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collContacts === null) {
			if ($this->isNew()) {
			   $this->collContacts = array();
			} else {
	   
				$criteria->add(ContactPeer::ACCOUNT_ID, $this->getAccountId());
				$this->collContacts = ContactPeer::doSelectJoinAccount($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ContactPeer::ACCOUNT_ID, $this->getAccountId());
			if (!isset($this->lastContactsCriteria) || !$this->lastContactsCriteria->equals($criteria)) {
				$this->collContacts = ContactPeer::doSelectJoinAccount($criteria, $con);
			}
		}
		$this->lastContactsCriteria = $criteria;

		return $this->collContacts;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Account is new, it will return
	 * an empty collection; or if this Account has previously
	 * been saved, it will retrieve related Contacts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Account.
	 */
	public function getContactsJoinAddressRelatedByHomeAddressId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'PHPARCH/ContactPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collContacts === null) {
			if ($this->isNew()) {
			   $this->collContacts = array();
			} else {
	   
				$criteria->add(ContactPeer::ACCOUNT_ID, $this->getAccountId());
				$this->collContacts = ContactPeer::doSelectJoinAddressRelatedByHomeAddressId($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ContactPeer::ACCOUNT_ID, $this->getAccountId());
			if (!isset($this->lastContactsCriteria) || !$this->lastContactsCriteria->equals($criteria)) {
				$this->collContacts = ContactPeer::doSelectJoinAddressRelatedByHomeAddressId($criteria, $con);
			}
		}
		$this->lastContactsCriteria = $criteria;

		return $this->collContacts;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Account is new, it will return
	 * an empty collection; or if this Account has previously
	 * been saved, it will retrieve related Contacts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Account.
	 */
	public function getContactsJoinAddressRelatedByWorkAddressId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'PHPARCH/ContactPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collContacts === null) {
			if ($this->isNew()) {
			   $this->collContacts = array();
			} else {
	   
				$criteria->add(ContactPeer::ACCOUNT_ID, $this->getAccountId());
				$this->collContacts = ContactPeer::doSelectJoinAddressRelatedByWorkAddressId($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ContactPeer::ACCOUNT_ID, $this->getAccountId());
			if (!isset($this->lastContactsCriteria) || !$this->lastContactsCriteria->equals($criteria)) {
				$this->collContacts = ContactPeer::doSelectJoinAddressRelatedByWorkAddressId($criteria, $con);
			}
		}
		$this->lastContactsCriteria = $criteria;

		return $this->collContacts;
	}



 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(AccountPeer::DATABASE_NAME);

		try {
			$con->begin();
			AccountPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(AccountPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = AccountPeer::doInsert($this, $con);
					$this->setAccountId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					AccountPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collContacts !== null) {
				for ($i=0,$size=count($this->collContacts); $i < $size; $i++) {
					$this->collContacts[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return AccountPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  

			if (($retval = AccountPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collContacts !== null) {
				for ($i=0,$size=count($this->collContacts); $i < $size; $i++) {
					if (($retval = $this->collContacts[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed account_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setAccountId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getAccountId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return Account Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new Account();
		$copyObj->setUsername($this->username);
		$copyObj->setPassword($this->password);
		$copyObj->setLastName($this->last_name);
		$copyObj->setFirstName($this->first_name);
		$copyObj->setIsEnabled($this->is_enabled);
		$copyObj->setIsAdmin($this->is_admin);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getContacts() as $relObj) {
				$copyObj->addContact($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setAccountId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return AccountPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new AccountPeer();
		}
		return self::$peer;
	}

}
