<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'PHPARCH/ListItem.php';
// (on-demand) include_once 'PHPARCH/ListItemPeer.php';

include_once 'PHPARCH/AddressPeer.php';

/**
 * Base class that represents a row from the 'address' table.
 *
 *  
 *
 * This class was autogenerated by Propel on:
 *
 * [05/11/05 20:21:01]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Address class. 
 * 
 * @package PHPARCH 
 */
abstract class BaseAddress extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var AddressPeer
	 */
	protected static $peer;

	/**
	 * The value for the address_id field.
	 * @var int	  
	 */
	protected $address_id;	

	/**
	 * The value for the line1 field.
	 * @var string	  
	 */
	protected $line1;	

	/**
	 * The value for the line2 field.
	 * @var string	  
	 */
	protected $line2;	

	/**
	 * The value for the city field.
	 * @var string	  
	 */
	protected $city;	

	/**
	 * The value for the state_id field.
	 * @var int	  
	 */
	protected $state_id;	

	/**
	 * The value for the zip_code field.
	 * @var string	  
	 */
	protected $zip_code;	
  
	/**
	 * Get the AddressId column value.
	 *  
	 * @return int	  
	 */
	public function getAddressId()
	{
		return $this->address_id;
	}


	/**
	 * Set the value of `address_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setAddressId($v)
	{
		if ($this->address_id !== $v) {
			$this->address_id = $v;
			$this->modifiedColumns[] = AddressPeer::ADDRESS_ID;
		}
			
		  // update associated Contact		  
		  if ($this->collContactsRelatedByHomeAddressId !== null) {
			  for ($i=0,$size=count($this->collContactsRelatedByHomeAddressId); $i < $size; $i++) {
				  $this->collContactsRelatedByHomeAddressId[$i]->setHomeAddressId($v);
			  }
		  }
			  	
		  // update associated Contact		  
		  if ($this->collContactsRelatedByWorkAddressId !== null) {
			  for ($i=0,$size=count($this->collContactsRelatedByWorkAddressId); $i < $size; $i++) {
				  $this->collContactsRelatedByWorkAddressId[$i]->setWorkAddressId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the Line1 column value.
	 *  
	 * @return string	  
	 */
	public function getLine1()
	{
		return $this->line1;
	}


	/**
	 * Set the value of `line1` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setLine1($v)
	{
		if ($this->line1 !== $v) {
			$this->line1 = $v;
			$this->modifiedColumns[] = AddressPeer::LINE1;
		}
				
	}

  
	/**
	 * Get the Line2 column value.
	 *  
	 * @return string	  
	 */
	public function getLine2()
	{
		return $this->line2;
	}


	/**
	 * Set the value of `line2` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setLine2($v)
	{
		if ($this->line2 !== $v) {
			$this->line2 = $v;
			$this->modifiedColumns[] = AddressPeer::LINE2;
		}
				
	}

  
	/**
	 * Get the City column value.
	 *  
	 * @return string	  
	 */
	public function getCity()
	{
		return $this->city;
	}


	/**
	 * Set the value of `city` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setCity($v)
	{
		if ($this->city !== $v) {
			$this->city = $v;
			$this->modifiedColumns[] = AddressPeer::CITY;
		}
				
	}

  
	/**
	 * Get the StateId column value.
	 *  
	 * @return int	  
	 */
	public function getStateId()
	{
		return $this->state_id;
	}


	/**
	 * Set the value of `state_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setStateId($v)
	{
		if ($this->state_id !== $v) {
			$this->state_id = $v;
			$this->modifiedColumns[] = AddressPeer::STATE_ID;
		}
			
		if ($this->aListItem !== null && $this->aListItem->getItemId() !== $v) {
			$this->aListItem = null;
		}
			
	}

  
	/**
	 * Get the ZipCode column value.
	 *  
	 * @return string	  
	 */
	public function getZipCode()
	{
		return $this->zip_code;
	}


	/**
	 * Set the value of `zip_code` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setZipCode($v)
	{
		if ($this->zip_code !== $v) {
			$this->zip_code = $v;
			$this->modifiedColumns[] = AddressPeer::ZIP_CODE;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->address_id = $rs->getInt($startcol + 0);					
			$this->line1 = $rs->getString($startcol + 1);					
			$this->line2 = $rs->getString($startcol + 2);					
			$this->city = $rs->getString($startcol + 3);					
			$this->state_id = $rs->getInt($startcol + 4);					
			$this->zip_code = $rs->getString($startcol + 5);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating Address object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(AddressPeer::DATABASE_NAME);
		$criteria->add(AddressPeer::ADDRESS_ID, $this->address_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(AddressPeer::DATABASE_NAME);
		if ($this->isColumnModified(AddressPeer::ADDRESS_ID)) $criteria->add(AddressPeer::ADDRESS_ID, $this->address_id);
		if ($this->isColumnModified(AddressPeer::LINE1)) $criteria->add(AddressPeer::LINE1, $this->line1);
		if ($this->isColumnModified(AddressPeer::LINE2)) $criteria->add(AddressPeer::LINE2, $this->line2);
		if ($this->isColumnModified(AddressPeer::CITY)) $criteria->add(AddressPeer::CITY, $this->city);
		if ($this->isColumnModified(AddressPeer::STATE_ID)) $criteria->add(AddressPeer::STATE_ID, $this->state_id);
		if ($this->isColumnModified(AddressPeer::ZIP_CODE)) $criteria->add(AddressPeer::ZIP_CODE, $this->zip_code);
		return $criteria;			
	}
	
	

	/**
	 * @var ListItem	  
	 */
	protected $aListItem;

	/**
	 * Declares an association between this object and a ListItem object
	 *
	 * @param ListItem $v
	 * @return void
	 * @throws PropelException
	 */
	public function setListItem($v)
	{
			
		if ($v === null) {
			$this->setStateId(NULL);
		} else {
			$this->setStateId($v->getItemId());
		}
   
		$this->aListItem = $v;
	}


	/**
	 * Get the associated ListItem object
	 *
	 * @param Connection Optional Connection object.
	 * @return ListItem The associated ListItem object.
	 * @throws PropelException
	 */
	public function getListItem($con = null)
	{
		// include the Peer class
		include_once 'PHPARCH/ListItemPeer.php';

		if ($this->aListItem === null && ($this->state_id !== null)) {
	
			$this->aListItem = ListItemPeer::retrieveByPK($this->state_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ListItemPeer::retrieveByPK($this->state_id, $con);
			   $obj->addAddresss($this);
			 */
		}
		return $this->aListItem;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setListItemKey($key)
	{

		$this->setStateId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collContactsRelatedByHomeAddressId	  
	 * @var array
	 */
	protected $collContactsRelatedByHomeAddressId; 

	/**
	 * Temporary storage of collContactsRelatedByHomeAddressId to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initContactsRelatedByHomeAddressId()
	{
		if ($this->collContactsRelatedByHomeAddressId === null) {
			$this->collContactsRelatedByHomeAddressId = array();
		}
	}

	/**
	 * Method called to associate a Contact object to this object
	 * through the Contact foreign key attribute
	 *
	 * @param Contact $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addContactRelatedByHomeAddressId(Contact $l)
	{
		$this->collContactsRelatedByHomeAddressId[] = $l;
		$l->setAddressRelatedByHomeAddressId($this);
	}

	/**
	 * The criteria used to select the current contents of collContactsRelatedByHomeAddressId.
	 * @var Criteria
	 */
	private $lastContactsRelatedByHomeAddressIdCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Address has previously
	 * been saved, it will retrieve related ContactsRelatedByHomeAddressId from storage.
	 * If this Address is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getContactsRelatedByHomeAddressId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'PHPARCH/ContactPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collContactsRelatedByHomeAddressId === null) {
			if ($this->isNew()) {
			   $this->collContactsRelatedByHomeAddressId = array();
			} else {
	
				$criteria->add(ContactPeer::HOME_ADDRESS_ID, $this->getAddressId() );

				$this->collContactsRelatedByHomeAddressId = ContactPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ContactPeer::HOME_ADDRESS_ID, $this->getAddressId());

				if (!isset($this->lastContactsRelatedByHomeAddressIdCriteria) || !$this->lastContactsRelatedByHomeAddressIdCriteria->equals($criteria)) {
					$this->collContactsRelatedByHomeAddressId = ContactPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastContactsRelatedByHomeAddressIdCriteria = $criteria;

		return $this->collContactsRelatedByHomeAddressId;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Address is new, it will return
	 * an empty collection; or if this Address has previously
	 * been saved, it will retrieve related ContactsRelatedByHomeAddressId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Address.
	 */
	public function getContactsRelatedByHomeAddressIdJoinAccount($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'PHPARCH/ContactPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collContactsRelatedByHomeAddressId === null) {
			if ($this->isNew()) {
			   $this->collContactsRelatedByHomeAddressId = array();
			} else {
	   
				$criteria->add(ContactPeer::HOME_ADDRESS_ID, $this->getAddressId());
				$this->collContactsRelatedByHomeAddressId = ContactPeer::doSelectJoinAccount($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ContactPeer::HOME_ADDRESS_ID, $this->getAddressId());
			if (!isset($this->lastContactsRelatedByHomeAddressIdCriteria) || !$this->lastContactsRelatedByHomeAddressIdCriteria->equals($criteria)) {
				$this->collContactsRelatedByHomeAddressId = ContactPeer::doSelectJoinAccount($criteria, $con);
			}
		}
		$this->lastContactsRelatedByHomeAddressIdCriteria = $criteria;

		return $this->collContactsRelatedByHomeAddressId;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Address is new, it will return
	 * an empty collection; or if this Address has previously
	 * been saved, it will retrieve related ContactsRelatedByHomeAddressId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Address.
	 */
	public function getContactsRelatedByHomeAddressIdJoinAddressRelatedByWorkAddressId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'PHPARCH/ContactPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collContactsRelatedByHomeAddressId === null) {
			if ($this->isNew()) {
			   $this->collContactsRelatedByHomeAddressId = array();
			} else {
	   
				$criteria->add(ContactPeer::HOME_ADDRESS_ID, $this->getAddressId());
				$this->collContactsRelatedByHomeAddressId = ContactPeer::doSelectJoinAddressRelatedByWorkAddressId($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ContactPeer::HOME_ADDRESS_ID, $this->getAddressId());
			if (!isset($this->lastContactsRelatedByHomeAddressIdCriteria) || !$this->lastContactsRelatedByHomeAddressIdCriteria->equals($criteria)) {
				$this->collContactsRelatedByHomeAddressId = ContactPeer::doSelectJoinAddressRelatedByWorkAddressId($criteria, $con);
			}
		}
		$this->lastContactsRelatedByHomeAddressIdCriteria = $criteria;

		return $this->collContactsRelatedByHomeAddressId;
	}

	/**
	 * Collection to store aggregation of collContactsRelatedByWorkAddressId	  
	 * @var array
	 */
	protected $collContactsRelatedByWorkAddressId; 

	/**
	 * Temporary storage of collContactsRelatedByWorkAddressId to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initContactsRelatedByWorkAddressId()
	{
		if ($this->collContactsRelatedByWorkAddressId === null) {
			$this->collContactsRelatedByWorkAddressId = array();
		}
	}

	/**
	 * Method called to associate a Contact object to this object
	 * through the Contact foreign key attribute
	 *
	 * @param Contact $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addContactRelatedByWorkAddressId(Contact $l)
	{
		$this->collContactsRelatedByWorkAddressId[] = $l;
		$l->setAddressRelatedByWorkAddressId($this);
	}

	/**
	 * The criteria used to select the current contents of collContactsRelatedByWorkAddressId.
	 * @var Criteria
	 */
	private $lastContactsRelatedByWorkAddressIdCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Address has previously
	 * been saved, it will retrieve related ContactsRelatedByWorkAddressId from storage.
	 * If this Address is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getContactsRelatedByWorkAddressId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'PHPARCH/ContactPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collContactsRelatedByWorkAddressId === null) {
			if ($this->isNew()) {
			   $this->collContactsRelatedByWorkAddressId = array();
			} else {
	
				$criteria->add(ContactPeer::WORK_ADDRESS_ID, $this->getAddressId() );

				$this->collContactsRelatedByWorkAddressId = ContactPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ContactPeer::WORK_ADDRESS_ID, $this->getAddressId());

				if (!isset($this->lastContactsRelatedByWorkAddressIdCriteria) || !$this->lastContactsRelatedByWorkAddressIdCriteria->equals($criteria)) {
					$this->collContactsRelatedByWorkAddressId = ContactPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastContactsRelatedByWorkAddressIdCriteria = $criteria;

		return $this->collContactsRelatedByWorkAddressId;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Address is new, it will return
	 * an empty collection; or if this Address has previously
	 * been saved, it will retrieve related ContactsRelatedByWorkAddressId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Address.
	 */
	public function getContactsRelatedByWorkAddressIdJoinAccount($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'PHPARCH/ContactPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collContactsRelatedByWorkAddressId === null) {
			if ($this->isNew()) {
			   $this->collContactsRelatedByWorkAddressId = array();
			} else {
	   
				$criteria->add(ContactPeer::WORK_ADDRESS_ID, $this->getAddressId());
				$this->collContactsRelatedByWorkAddressId = ContactPeer::doSelectJoinAccount($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ContactPeer::WORK_ADDRESS_ID, $this->getAddressId());
			if (!isset($this->lastContactsRelatedByWorkAddressIdCriteria) || !$this->lastContactsRelatedByWorkAddressIdCriteria->equals($criteria)) {
				$this->collContactsRelatedByWorkAddressId = ContactPeer::doSelectJoinAccount($criteria, $con);
			}
		}
		$this->lastContactsRelatedByWorkAddressIdCriteria = $criteria;

		return $this->collContactsRelatedByWorkAddressId;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Address is new, it will return
	 * an empty collection; or if this Address has previously
	 * been saved, it will retrieve related ContactsRelatedByWorkAddressId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Address.
	 */
	public function getContactsRelatedByWorkAddressIdJoinAddressRelatedByHomeAddressId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'PHPARCH/ContactPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collContactsRelatedByWorkAddressId === null) {
			if ($this->isNew()) {
			   $this->collContactsRelatedByWorkAddressId = array();
			} else {
	   
				$criteria->add(ContactPeer::WORK_ADDRESS_ID, $this->getAddressId());
				$this->collContactsRelatedByWorkAddressId = ContactPeer::doSelectJoinAddressRelatedByHomeAddressId($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ContactPeer::WORK_ADDRESS_ID, $this->getAddressId());
			if (!isset($this->lastContactsRelatedByWorkAddressIdCriteria) || !$this->lastContactsRelatedByWorkAddressIdCriteria->equals($criteria)) {
				$this->collContactsRelatedByWorkAddressId = ContactPeer::doSelectJoinAddressRelatedByHomeAddressId($criteria, $con);
			}
		}
		$this->lastContactsRelatedByWorkAddressIdCriteria = $criteria;

		return $this->collContactsRelatedByWorkAddressId;
	}



 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(AddressPeer::DATABASE_NAME);

		try {
			$con->begin();
			AddressPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(AddressPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aListItem !== null) {
				if ($this->aListItem->isModified()) $this->aListItem->save($con);
				$this->setListItem($this->aListItem);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = AddressPeer::doInsert($this, $con);
					$this->setAddressId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					AddressPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collContactsRelatedByHomeAddressId !== null) {
				for ($i=0,$size=count($this->collContactsRelatedByHomeAddressId); $i < $size; $i++) {
					$this->collContactsRelatedByHomeAddressId[$i]->save($con);
				}
			  }
			if ($this->collContactsRelatedByWorkAddressId !== null) {
				for ($i=0,$size=count($this->collContactsRelatedByWorkAddressId); $i < $size; $i++) {
					$this->collContactsRelatedByWorkAddressId[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return AddressPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aListItem !== null) {
				if (($retval = $this->aListItem->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = AddressPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collContactsRelatedByHomeAddressId !== null) {
				for ($i=0,$size=count($this->collContactsRelatedByHomeAddressId); $i < $size; $i++) {
					if (($retval = $this->collContactsRelatedByHomeAddressId[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collContactsRelatedByWorkAddressId !== null) {
				for ($i=0,$size=count($this->collContactsRelatedByWorkAddressId); $i < $size; $i++) {
					if (($retval = $this->collContactsRelatedByWorkAddressId[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed address_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setAddressId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getAddressId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return Address Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new Address();
		$copyObj->setLine1($this->line1);
		$copyObj->setLine2($this->line2);
		$copyObj->setCity($this->city);
		$copyObj->setStateId($this->state_id);
		$copyObj->setZipCode($this->zip_code);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getContactsRelatedByHomeAddressId() as $relObj) {
				$copyObj->addContactRelatedByHomeAddressId($relObj->copy());
			}

			foreach($this->getContactsRelatedByWorkAddressId() as $relObj) {
				$copyObj->addContactRelatedByWorkAddressId($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setAddressId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return AddressPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new AddressPeer();
		}
		return self::$peer;
	}

}
