<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';

include_once 'PHPARCH/ListItemPeer.php';

/**
 * Base class that represents a row from the 'list_item' table.
 *
 *  
 *
 * This class was autogenerated by Propel on:
 *
 * [05/11/05 20:21:01]
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to ListItem class. 
 * 
 * @package PHPARCH 
 */
abstract class BaseListItem extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var ListItemPeer
	 */
	protected static $peer;

	/**
	 * The value for the item_id field.
	 * @var int	  
	 */
	protected $item_id;	

	/**
	 * The value for the group_name field.
	 * @var string	  
	 */
	protected $group_name = '';	

	/**
	 * The value for the short_name field.
	 * @var string	  
	 */
	protected $short_name = '';	

	/**
	 * The value for the description field.
	 * @var string	  
	 */
	protected $description;	

	/**
	 * The value for the is_enabled field.
	 * @var int	  
	 */
	protected $is_enabled = 1;	

	/**
	 * The value for the sort_order field.
	 * @var int	  
	 */
	protected $sort_order = 0;	
  
	/**
	 * Get the ItemId column value.
	 *  
	 * @return int	  
	 */
	public function getItemId()
	{
		return $this->item_id;
	}


	/**
	 * Set the value of `item_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setItemId($v)
	{
		if ($this->item_id !== $v) {
			$this->item_id = $v;
			$this->modifiedColumns[] = ListItemPeer::ITEM_ID;
		}
			
		  // update associated Address		  
		  if ($this->collAddresss !== null) {
			  for ($i=0,$size=count($this->collAddresss); $i < $size; $i++) {
				  $this->collAddresss[$i]->setStateId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the GroupName column value.
	 *  
	 * @return string	  
	 */
	public function getGroupName()
	{
		return $this->group_name;
	}


	/**
	 * Set the value of `group_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setGroupName($v)
	{
		if ($this->group_name !== $v || $v === '') {
			$this->group_name = $v;
			$this->modifiedColumns[] = ListItemPeer::GROUP_NAME;
		}
				
	}

  
	/**
	 * Get the ShortName column value.
	 *  
	 * @return string	  
	 */
	public function getShortName()
	{
		return $this->short_name;
	}


	/**
	 * Set the value of `short_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setShortName($v)
	{
		if ($this->short_name !== $v || $v === '') {
			$this->short_name = $v;
			$this->modifiedColumns[] = ListItemPeer::SHORT_NAME;
		}
				
	}

  
	/**
	 * Get the Description column value.
	 *  
	 * @return string	  
	 */
	public function getDescription()
	{
		return $this->description;
	}


	/**
	 * Set the value of `description` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setDescription($v)
	{
		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = ListItemPeer::DESCRIPTION;
		}
				
	}

  
	/**
	 * Get the IsEnabled column value.
	 *  
	 * @return int	  
	 */
	public function getIsEnabled()
	{
		return $this->is_enabled;
	}


	/**
	 * Set the value of `is_enabled` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setIsEnabled($v)
	{
		if ($this->is_enabled !== $v || $v === 1) {
			$this->is_enabled = $v;
			$this->modifiedColumns[] = ListItemPeer::IS_ENABLED;
		}
				
	}

  
	/**
	 * Get the SortOrder column value.
	 *  
	 * @return int	  
	 */
	public function getSortOrder()
	{
		return $this->sort_order;
	}


	/**
	 * Set the value of `sort_order` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setSortOrder($v)
	{
		if ($this->sort_order !== $v || $v === 0) {
			$this->sort_order = $v;
			$this->modifiedColumns[] = ListItemPeer::SORT_ORDER;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->item_id = $rs->getInt($startcol + 0);					
			$this->group_name = $rs->getString($startcol + 1);					
			$this->short_name = $rs->getString($startcol + 2);					
			$this->description = $rs->getString($startcol + 3);					
			$this->is_enabled = $rs->getInt($startcol + 4);					
			$this->sort_order = $rs->getInt($startcol + 5);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating ListItem object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(ListItemPeer::DATABASE_NAME);
		$criteria->add(ListItemPeer::ITEM_ID, $this->item_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(ListItemPeer::DATABASE_NAME);
		if ($this->isColumnModified(ListItemPeer::ITEM_ID)) $criteria->add(ListItemPeer::ITEM_ID, $this->item_id);
		if ($this->isColumnModified(ListItemPeer::GROUP_NAME)) $criteria->add(ListItemPeer::GROUP_NAME, $this->group_name);
		if ($this->isColumnModified(ListItemPeer::SHORT_NAME)) $criteria->add(ListItemPeer::SHORT_NAME, $this->short_name);
		if ($this->isColumnModified(ListItemPeer::DESCRIPTION)) $criteria->add(ListItemPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(ListItemPeer::IS_ENABLED)) $criteria->add(ListItemPeer::IS_ENABLED, $this->is_enabled);
		if ($this->isColumnModified(ListItemPeer::SORT_ORDER)) $criteria->add(ListItemPeer::SORT_ORDER, $this->sort_order);
		return $criteria;			
	}
	
	

	/**
	 * Collection to store aggregation of collAddresss	  
	 * @var array
	 */
	protected $collAddresss; 

	/**
	 * Temporary storage of collAddresss to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initAddresss()
	{
		if ($this->collAddresss === null) {
			$this->collAddresss = array();
		}
	}

	/**
	 * Method called to associate a Address object to this object
	 * through the Address foreign key attribute
	 *
	 * @param Address $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addAddress(Address $l)
	{
		$this->collAddresss[] = $l;
		$l->setListItem($this);
	}

	/**
	 * The criteria used to select the current contents of collAddresss.
	 * @var Criteria
	 */
	private $lastAddresssCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this ListItem has previously
	 * been saved, it will retrieve related Addresss from storage.
	 * If this ListItem is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getAddresss($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'PHPARCH/AddressPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collAddresss === null) {
			if ($this->isNew()) {
			   $this->collAddresss = array();
			} else {
	
				$criteria->add(AddressPeer::STATE_ID, $this->getItemId() );

				$this->collAddresss = AddressPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(AddressPeer::STATE_ID, $this->getItemId());

				if (!isset($this->lastAddresssCriteria) || !$this->lastAddresssCriteria->equals($criteria)) {
					$this->collAddresss = AddressPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastAddresssCriteria = $criteria;

		return $this->collAddresss;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this ListItem is new, it will return
	 * an empty collection; or if this ListItem has previously
	 * been saved, it will retrieve related Addresss from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in ListItem.
	 */
	public function getAddresssJoinListItem($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'PHPARCH/AddressPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collAddresss === null) {
			if ($this->isNew()) {
			   $this->collAddresss = array();
			} else {
	   
				$criteria->add(AddressPeer::STATE_ID, $this->getItemId());
				$this->collAddresss = AddressPeer::doSelectJoinListItem($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(AddressPeer::STATE_ID, $this->getItemId());
			if (!isset($this->lastAddresssCriteria) || !$this->lastAddresssCriteria->equals($criteria)) {
				$this->collAddresss = AddressPeer::doSelectJoinListItem($criteria, $con);
			}
		}
		$this->lastAddresssCriteria = $criteria;

		return $this->collAddresss;
	}



 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(ListItemPeer::DATABASE_NAME);

		try {
			$con->begin();
			ListItemPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(ListItemPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ListItemPeer::doInsert($this, $con);
					$this->setItemId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					ListItemPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collAddresss !== null) {
				for ($i=0,$size=count($this->collAddresss); $i < $size; $i++) {
					$this->collAddresss[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return ListItemPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  

			if (($retval = ListItemPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collAddresss !== null) {
				for ($i=0,$size=count($this->collAddresss); $i < $size; $i++) {
					if (($retval = $this->collAddresss[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed item_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setItemId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getItemId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return ListItem Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new ListItem();
		$copyObj->setGroupName($this->group_name);
		$copyObj->setShortName($this->short_name);
		$copyObj->setDescription($this->description);
		$copyObj->setIsEnabled($this->is_enabled);
		$copyObj->setSortOrder($this->sort_order);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getAddresss() as $relObj) {
				$copyObj->addAddress($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setItemId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return ListItemPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ListItemPeer();
		}
		return self::$peer;
	}

}
