<?php

/* Reminder: always indent with 4 spaces (no tabs). */

/**
 * PHPARCH - Contact Manager
 *
 * @author Tony Bibbs <tony@geeklog.net>
 * @copyright 2005
 * @version $Id:$
 *
 */

/**
 * Abstract class that knows how to handle active user sessions
 */
require_once 'BaseViewFlexyUser.php';

/**
 * Shows contact search results
 *
 * @author Tony Bibbs <tony@geeklog.net>
 *
 */
class PHPARCH_ContactSearchResults extends PHPARCH_BaseViewFlexyUser {
    /**
     * Holds the contacts that matched the search results
     * @var array
     * @access public
     */
    public $contacts = array();

    /**
     * Shows contact search results
     *
     * By this time we already have the search results jammed in $_REQUEST, so all we have to do
     * here is simply show them. 
     *
     * @author Tony Bibbs <tony@geeklog.net>
     * @access public
     * 
     */
    public function processView()
    {       
        $this->contacts = $_REQUEST['contacts'];
        $this->setPageTitle('PHPARCH - Contact Search Results');
        $this->showHeader(true);
        $this->flexyHandle->compile('ContactSearchResults.thtml');
        $this->flexyHandle->outputObject($this); 
        $this->showFooter();
    }
    
    /**
     * Returns how many contacts matched the search criteria
     *
     * This is used by the Flexy template
     *
     * @author Tony Bibbs <tony@geeklog.net
     * @access public
     * @return int Number of contacts that mactched the search
     *
     */
    public function getNumContacts() 
    {
        return count($this->contacts);
    }
}

?>