<?php

/* Reminder: always indent with 4 spaces (no tabs). */

/**
 * DVRS Improving Transition Outcommes.
 *
 * @author Tony Bibbs <tony@geeklog.net>
 * @copyright 2005
 * @version $Id:$
 *
 */

/**
 * Abstract class that knows how to handle active user sessions
 */
require_once 'BaseViewFlexyUser.php';

/**
 * Called as a last ditch effort to gracefully handle an uncaught exception.
 *
 * @author Tony Bibbs <tony@geeklog.net>
 *
 */
class PHPARCH_showErrorView extends PHPARCH_BaseViewFlexyUser {
    /**
     * Handle to the exception that is causing this trouble
     * @var Exception
     * @access public
     */
    public $passedException = null;
    
    /**
     * Get the user object if we get one but don't require oen
     *
     * @author Tony Bibbs <tony@geeklog.net>
     * @access public
     * 
     */
    public function __construct()
    {
        $this->setUserRequired(false);
        parent::__construct();        
    }
    
    /**
     * Shows the login page
     *
     * If we don't have a user object, we show the login page.  Otherwise we forward  the user on
     * to the user home page
     *
     * @author Tony Bibbs <tony@geeklog.net>
     * @access public
     * 
     */
    public function processView()
    {
        $this->passedException = $_REQUEST['exception'];   
        
        // Ok, user is not logged in, turn of the navbar and show the login screen.
        $this->setPageTitle('PHPARCH - Contact Manager Error');
    	$this->showHeader();
    	$this->flexyHandle->compile('Error.thtml');
        $this->flexyHandle->outputObject($this);       
        $this->showFooter();
    }
}

?>